/* ---------------------------------

written by Mark Hicken (nekcih@yahoo.com)

These functions extend the JS Array object adding primarily to the associative array

EXAMPLE USAGE:

a.count(); // returns the true length of the associative array
a.getElementAt(3); // returns the element at position 3 of the array (works with associative arrays)
a.getElementPosition('key'); // returns the position of an element with the passed in key

note there are more functions below

----------------------------------- */


// Returns a boolean of wheather or not a value is in an array
Array.prototype.contains = function(arrayItem) {
	itemExists=false;
	for(i=0; i<this.length; i++) {
		if(this[i]==arrayItem) { itemExists=true; }
	}
	return itemExists;
}

// Deletes an array element while keep the array in the same order
Array.prototype.remove = function(delItem) {
	for(i=0; i<this.length; i++) {
		if(this[i]==delItem) {
			//mark the item number for array reordering
			iKill=i;
			//move last array item to current location
			this[i]=this[this.length-1];
			//replace last array item with current item
			this[this.length-1]=delItem;
			//chop it off of the array
			this.length=this.length-1;
		}
	}
	if(typeof(iKill)!="undefined") {
		//put the array back to it's original order
		for(i=iKill; i<this.length; i++) {
			swap1=this[i];
			if(typeof(this[i+1])!="undefined") { 
				swap2=this[i+1]; 
				this[i]=swap2;
				this[i+1]=swap1;
			}
		}
	}
	return this;
}

// --------------------------------------------------------------
// Although these functions should work for a standard array
// they are intended to add functionality to associative arrays
// --------------------------------------------------------------

// Returns the true length of an Array Object including an associative array
Array.prototype.count = function() {
	var i=0;
	for(x in this) { i++; }
	return i;
}

// for retrieving an element at a specific index from an associative array
Array.prototype.getElementAt = function(iIndex) {
	var i=0;
	for(x in this) {
		if(i==iIndex) { return this[x]; }
		i++;
	}
	return null; // didn't find an element at that index
}

// for retrieving an element's position in an associative array
Array.prototype.getElementPosition = function(sKey) { 
	var i=0;
	for(x in this) {
		if(x==sKey) { return i; }
		i++;
	}
	
	// if that didn't work, try it as a regular indexed array
	i=0;
	for(x in this) {
		if(this[x]==sKey) { return i; }
		i++;
	}

	// if neither worked return a null value
	return null; // didn't find an element with that key
}

// Adds an item to the array if the element isn't already there
Array.prototype.add = function(addItem) {
	if(!this.contains(addItem)) { 
		this[this.length]=addItem; 
	}
	return this;
}
