/* ---------------------------------

written by Mark Hicken (nekcih@yahoo.com)

EXAMPLE USAGE:

<script type="text/javascript" src="debugConsole.js"></script>
<script type="text/javascript">
	debug.enabled = true; // not required because it defaults to true
	debug.show('my debug message'); // use the debug function through out your code
</script>

----------------------------------- */

// debug tools
var debug = new Object();

debug.enabled = true; // global debug enabled or not

debug.getConsole = null;
debug.createConsole = function() {
	var c = document.createElement('div');
	c.setAttribute('id', 'debugConsole');
	c.style.border = '2px solid #999999';
	c.style.padding = '5px';
	c.style.fontSize = '9px';
	c.style.backgroundColor = '#FFFFFF';
	c.innerHTML += '<strong>// Debug Console by Mark Hicken (nekcih@yahoo.com)</strong><br />';
	
	document.body.appendChild(c);
	this.getConsole = function() { return document.getElementById('debugConsole'); }
}

// primary public vars
debug.lastMessage = "";
debug.allMessages = "";
debug.show = function(sMessage) {
	this.lastMessage = sMessage;
	this.allMessages += sMessage+'<br />\r\n';
	if(this.enabled) {
		if(this.getConsole==null) { this.createConsole(); }
		this.getConsole().innerHTML += '<br />'+sMessage;
	}
}

// try to check debug using Mark Hicken's querystring function
if(typeof(queryString)!="undefined") {
	if(queryString("debug").toLowerCase()=="on" || queryString("debug").toLowerCase()=="true") {
		debug.enabled = true;
	}
}
