/* ---------------------------------

written by Mark Hicken (nekcih@yahoo.com)

This function overrides the enter key and instead of submitting a form, it
tabs to the next field.

You must add the id property to all tabbable form elements!

// EXAMPLE USAGE:
tabManager.onTabbed = function() { 
	// do function code here
}
tabManager.enable('field1', 'field2', 'field3'); // enable fields

----------------------------------- */

var tabManager = new Object();
tabManager.aTabFieldIds = new Array();
tabManager.onTabbed = new Function();
tabManager.limitTypes = false;
tabManager.aTabFieldTypes = ['text', 'checkbox', 'select-one', 'select-multiple', 'radio', 'image', 'file'];
tabManager.enable = function(aTabFieldIds) {
	tabManager.aTabFieldIds = new Array();
	for(var i=0; i<arguments.length; i++) { tabManager.aTabFieldIds.push(arguments[i]); } // build fields array
	tabManager.iNextField = 0;
	tabManager._enabled = true;
	document.onkeypress = tabManager.stopRKey;
	// attach loadHandler
	if (window.attachEvent) { window.attachEvent('onload', tabManager.configAllTabFields); }
	else if (window.addEventListener) { window.addEventListener('load', tabManager.configAllTabFields, false); }
}
tabManager.disable = function() {
	tabManager._enabled = false;
}
tabManager.configAllTabFields = function() {
	var _aTabFields = tabManager.aTabFieldIds;
	if(tabManager.limitTypes) { tabManager.aTabFieldIds = new Array(); } // reset it so we can rebuild it
	for(var i=0; i<_aTabFields.length; i++) {
		var o = document.getElementById(_aTabFields[i]);
		if(o) {
			if(tabManager.limitTypes && tabManager.isValidNodeType(o.type)) { 
				alert('limiting types');
				tabManager.aTabFieldIds.push(_aTabFields[i]);  // rebuild the array based on allowed field types
			}
			o.onfocus = function() { if(tabManager._enabled) { tabManager.tabFieldFocus(this.id); } }
		}
	}
}
tabManager.isValidNodeType = function(sType) {
	for(var i=0; i<tabManager.aTabFieldTypes.length; i++) {
		if(sType == tabManager.aTabFieldTypes[i]) { return true; }
	}
	return false;
}
tabManager.tabFieldFocus = function(sId) {
	if(tabManager.aTabFieldIds.getElementPosition(sId) < tabManager.aTabFieldIds.length-1) {
		tabManager.iNextField = tabManager.aTabFieldIds.getElementPosition(sId)+1;
	}
	else { tabManager.iNextField = 0; }

	var o = document.getElementById(sId);
	if(o.select) { o.select(); }
}
tabManager.stopRKey = function(e) {
	var e = (e) ? e : ((event) ? event : null); 
	var node = (e.target) ? e.target : ((e.srcElement) ? e.srcElement : null); 
	if (e.keyCode==13 && (!tabManager.limitTypes || (tabManager.limitTypes && tabManager.isValidNodeType(node.type))))  { 
		if(node.type!='submit') {
			if(node.type!='textarea') {
				var o = document.getElementById(tabManager.aTabFieldIds[tabManager.iNextField]);
				if(o.focus) { o.focus(); }
				if(o.select) { o.select(); }
				unselectAll();
				if(typeof(tabManager.onTabbed)=="function") { tabManager.onTabbed(); }

				return false; // don't submit it
			}
		}
	} 
} 

// for retrieving an element's position in an associative or indexed array
Array.prototype.getElementPosition = function(sKey) { 
	for(var i=0; i<this.length; i++) { if(this[i]==sKey) { return i; } }
	return null; // didn't find an element with that key
}
function unselectAll() {
	if (document.selection) { document.selection.empty(); }
	else if (window.getSelection) { window.getSelection().removeAllRanges(); }
}