/* ---------------------------------

written by Mark Hicken (nekcih@yahoo.com)

// EXAMPLE USAGE:

var fSuccess = function(oXml) { xmlLoadHandler(oXml); }
var fFailure = function(oXml, sError) { alert('Error loading XML file: \r\n' + sError); }
loadXml("data.xml", fSuccess, fFailure, true);

Note that this function doesn't support a loadFailure function
if you need that functionality you can use loadXmlHttp

Note that the xml object gets passed to the loadhandler (fOnSuccess)

----------------------------------- */

function loadXml(sXml, fOnSuccess, fOnFailure, bAsynchronous)
{
	var xmlDoc;
	if(typeof(bAsynchronous) == "undefined") { bAsynchronous = true; }
	
	// code for IE
	if (window.ActiveXObject)
	{
		xmlDoc = new ActiveXObject("Microsoft.XMLDOM");
		xmlDoc.async = bAsynchronous;
		xmlDoc.load(sXml);
		if(xmlDoc.parseError.errorCode == 0) { fOnSuccess(xmlDoc); }
		else { fOnFailure(xmlDoc, xmlDoc.parseError.reason); }
	}
	// code for Mozilla, etc.
	else if (document.implementation && document.implementation.createDocument)
	{
		xmlDoc = document.implementation.createDocument("","",null);
		xmlDoc.async = bAsynchronous;
		xmlDoc.onload = function() { fOnSuccess(xmlDoc); }
		try { xmlDoc.load(sXml); } 
		catch(e) { fOnFailure(xmlDoc, e.message); }
	}
	else
	{
		alert('Your browser does not support this XML loader.');
	}
}
