/* ---------------------------------

written by Mark Hicken (nekcih@yahoo.com)

EXAMPLE USAGE:

// set up success and failure functions
docOnLoad = function(xmlhttp) { alert("XML data OK: "+xmlhttp.responseText); }
docOnFailure = function(xmlhttp) { alert("Unable to communicate with server.\r\nPlease try again in a moment.\r\n\r\nStatus: "+xmlhttp.statusText); }

// execute asynchronous load (continues code execution while loading)
window.onload = function() { loadXmlHttp('myDoc.txt',  docOnLoad, docOnFailure); }

// or execute synchronous load (waits for response)
window.onload = function() { loadXmlHttp('myDoc.txt',  docOnLoad, docOnFailure, false); }

----------------------------------- */

function loadXmlHttp(sUrl, fOnSuccess, fOnFailure, bAsynchronous) { // fOnSuccess and fOnFailure can be a string to eval or a function to execute
	debug.show("Requesting:\r\n"+sUrl);
	var xmlhttp;
	if(typeof(bAsynchronous)=="undefined") { bAsynchronous = true; }

	if (window.XMLHttpRequest) { // code for Mozilla, etc.
		xmlhttp=new XMLHttpRequest();
		if(bAsynchronous) { xmlhttp.onreadystatechange = function() { state_Change(xmlhttp, fOnSuccess, fOnFailure); } }
		xmlhttp.open("GET", sUrl, bAsynchronous);
		xmlhttp.send(null);
		if(!bAsynchronous) { state_Change(xmlhttp, fOnSuccess, fOnFailure); }
	}
	else if (window.ActiveXObject) { // code for IE
		xmlhttp=new ActiveXObject("Microsoft.XMLHTTP");
		if (xmlhttp) {
			if(bAsynchronous) { xmlhttp.onreadystatechange = function() { state_Change(xmlhttp, fOnSuccess, fOnFailure); } }
			xmlhttp.open("GET", sUrl, bAsynchronous);
			xmlhttp.send();
			if(!bAsynchronous) { state_Change(xmlhttp, fOnSuccess, fOnFailure); }
		}
	}
}

// readyState: 0 = uninitialized, 1 = loading, 2 = loaded, 3 = interactive, 4 = complete
function state_Change(xmlhttp, fOnSuccess, fOnFailure) { // gets executed each time the state changes durring loading
	if(typeof(fOnSuccess!="undefined") || typeof(fOnFailure)!="undefined") {
		if (xmlhttp.readyState==4) { // if xmlhttp shows "loaded"
			if (xmlhttp.status==200) { // if loaded "OK"
				debug.show("Returned:\r\n"+xmlhttp.responseText);

				if(typeof(fOnSuccess) == "function") { fOnSuccess(xmlhttp); } // return the xmlhttp object to the success function for further execution
				else { eval(fOnSuccess)(xmlhttp); } // return the xmlhttp object to the success function for further execution
			}
			else {
				if(typeof(fOnFailure) == "function") { fOnFailure(xmlhttp); } // return the xmlhttp object to the failure function for further execution
				else { eval(fOnFailure)(xmlhttp); } // return the xmlhttp object to the failure function for further execution
			}
		}
	}
}


//for IE
if(typeof(debug)=="undefined") { debug = new Object(); debug.show = function(sNone) {} }
