/* ---------------------------------

written by Mark Hicken (nekcih@yahoo.com)

This function fades an object and saves and removes it's eventHandlers for re-enabling
in order to use the fade, you should include setAlpha.js before this file

EXAMPLE USAGE:

objEnabled('objectID', false); // fade down and remove event handlers
objEnabled('objectID', true); // fade up and reapply saved event handlers

----------------------------------- */

function objEnabled(sId, bEnabled) {
	// events to back up and restore:
	// ------------------------------
	// mouse events
	// form and other element events
	// keyboard events
	// window events
	var aEventsToBackup = ["onclick","ondblclick","onmousedown","onmouseup","onmouseover","onmouseout","onmousemove",
					"onchange","onfocus","onblur","onsubmit","onreset",
					"onkeydown","onkeyup","onkeypress",
					"onload","onabort","onunload","onresize","onselect","onerror"];

	oObj = document.getElementById(sId);

	if(typeof(oObj)!="undefined" && oObj!=null) {
		if(!bEnabled) { // disable object
			if(typeof(oObj.disabled) == "undefined") { // probably not a form element
				for(var i in aEventsToBackup) { // for each event
					var sEvent = aEventsToBackup[i];
					
					eval("oObj._"+sEvent+" = oObj."+sEvent); // backup event
				
					var fNull = function() {}
					eval("oObj."+sEvent+" = fNull"); // clear event
				}
				try { setAlpha(oObj, 20); } catch(e) {}
			}
			else { // probably a form element
				try { oObj.disabled = true; } catch(e) {}
			}
		}
		else { // enable object
			if(typeof(oObj.disabled) == "undefined") { // probably not a form element
				for(var i in aEventsToBackup) { // for each event
					var sEvent = aEventsToBackup[i];
					
					try {
						// if(i==0) { alert(oObj.id+":"+sEvent+" = "+eval("oObj."+sEvent)); }
						eval("oObj."+sEvent+" = oObj._"+sEvent); // restore event
					}
					catch(e) {}
				}
				try { setAlpha(oObj, 100); } catch(e) {}
			}
			else { // probably a form element
				try { oObj.disabled = false; } catch(e) {}
			}
		}
	}
}
