/* ---------------------------------

written by Mark Hicken (nekcih@yahoo.com)

This script will write files and folders to the local file system

EXAMPLE USAGE:

<html>
<body>
	<script type="text/javascript">
		// make a folder called "new" in the current folder
		var folder = makeFolder('new', '~currentFolder~', false);
		// write a file named 'newFile.txt' inside the previously created folder
		writeFile('newFile.txt', folder, true, 'This is the file contents.');
		// read a file named newFile.txt
		readFile('newFile.txt', folder); // returns a string of the file contents
	</script>
</body>
</html>

----------------------------------- */

// path can be ~currentPath~ or ~myDocuments~ or an actual string path
function writeFile(sFileName, sPath, bOverwrite, sContents) {
	try {
		sPath = getPathHook(sPath); // check for special paths etc
		bOverwrite = (bOverwrite); // make sure it's a boolean

		var fso = new ActiveXObject('Scripting.FileSystemObject'); 
	
		// create the file
		var sFileNameFullPath = sPath + '\\' + sFileName;
	
		var file = fso.CreateTextFile(sFileNameFullPath, bOverwrite);
		file.WriteLine(sContents); 
		file.Close();
		file = null;
		fso = null;
		
		return sFileNameFullPath; // successfully created and wrote file
	}
	catch(e) {
		return false;
	}
}
function readFile(sFileName, sPath) {
	try {
		sPath = getPathHook(sPath); // check for special paths etc

		var fso = new ActiveXObject('Scripting.FileSystemObject'); 

		// create the file
		var sFileNameFullPath = sPath + '\\' + sFileName;

		ts = fso.OpenTextFile(sFileNameFullPath);
		sFileContents = ts.ReadAll();
		ts.Close();

		ts = null;
		fso = null;
		
		return sFileContents; // successfully created and wrote file
	}
	catch(e) {
		return false;
	}
}
function makeFolder(sFolderName, sPath, bMakeHidden) {
	try {
		sPath = getPathHook(sPath); // check for special paths etc

		var fso = new ActiveXObject('Scripting.FileSystemObject'); 

		// create the folder or get it if it already exists
		var sNewFolderPath = sPath + '\\' + sFolderName;
		if(!fso.FolderExists(sNewFolderPath)) { folder = fso.CreateFolder(sNewFolderPath); }
		else { folder = fso.GetFolder(sNewFolderPath); }
	
		// make it a hidden folder	
		if(bMakeHidden && folder.attributes) {
			folder.attributes = folder.attributes + 2; 
		}
		
		// cleanup
		folder = null;
		fso = null;
		
		return sNewFolderPath; // successfully created and hidden
	}
	catch(e) {
		return false;
	}
}
function getPathHook(sPath) {
	if(!sPath) { sPath = getCurrentFolder(); } // if no path was passed then save in current folder
	else if(sPath.indexOf('~currentFolder~') != -1) { sPath = sPath.replace('~currentFolder~', getCurrentFolder()); }
	else if(sPath == '~myDocuments~') { sPath = getMyDocumentsFolder(); } // check if it's the "My Documents" folder
	return sPath;
}
function getCurrentFolder() {
	sCurPath = document.URLUnencoded.replace('file://', '');
	if(sCurPath.indexOf('.') != -1) {
		sCurPath = sCurPath.substring(0, sCurPath.lastIndexOf('\\'));
	}
	return sCurPath;
}
function getMyDocumentsFolder() {
	var ws_shell = new ActiveXObject('WScript.Shell');
	var sMyDocs = ws_shell.SpecialFolders('MyDocuments');
	return sMyDocs;
}
