/* ---------------------------------

collected and fixed by Mark Hicken (nekcih@yahoo.com)

// the infamous missing getElementsByClass function
// node = the document element to search (only it's children)
// tag = limit the search to a specific tag

EXAMPLE USAGE:

document.getElementsByClass(className); // returns all elements that use className
document.getElementsByClass(className, document.body.div1); // returns all elements in document.body.div1 that use className
document.getElementsByClass(className, null, div); // returns all div elements that use className

----------------------------------- */


// returns an array of document elements which use the requested className
function getElementsByClass(sClass, node, tag) {
	var classElements = new Array();
	if(node == null) { node = document; }
	if(tag == null) { tag = '*'; }
	
	var aElementsByTagName = node.getElementsByTagName(tag);
	var pattern = new RegExp("(^|\\s)"+sClass+"(\\s|$)");

	for(var i=0; i<aElementsByTagName.length; i++) {
		if(pattern.test(aElementsByTagName[i].className)) {
			classElements[i] = aElementsByTagName[i];
		}
	}
	
	return classElements;
}
document.getElementsByClassName = getElementsByClass;
document.getElementsByClass = getElementsByClass;
