/* ---------------------------------

written by Mark Hicken (nekcih@yahoo.com)

This script will display the contents of the currently loaded stylesheets

EXAMPLE USAGE:

<html>
<body>
	<script type="text/javascript">
		writeStyleSheets(); // writes all loaded stylesheets and their styles to the page
	</script>
</body>
</html>

----------------------------------- */

var totalRuleCount=0;
var count = -1;

function toggleElement(sElementId, bBlock) {
	if(document.getElementById) {
		var el=document.getElementById(sElementId);
		var sShowing=(bBlock) ? 'block' : 'inline' ;
		if (el != null) (el.style.display=='none') ? el.style.display=sShowing : el.style.display='none';
	}
	else { alert('Your browser does not support this property.'); }
}

function expColAllRules() {
	count++;
	if (count < totalRuleCount){
		toggleElement('plus'+count);
		toggleElement('minus'+count);
		toggleElement('cssText'+count, true);
		setTimeout('expColAllRules()', 1);
	} else {
		var oToggleLink = document.getElementById('toggleLink');
		(oToggleLink.innerHTML == 'Expand All') ? (oToggleLink.innerHTML='Collapse All') : (oToggleLink.innerHTML='Expand All');
		toggleElement('working', true);
		count = -1;
	}
}

function getRules(ssStyleSheet) {
	if (ssStyleSheet.cssRules) { return ssStyleSheet.cssRules; }
	else { return ssStyleSheet.rules; }
}
function getRuleText(ssRule) {
	if (ssRule.style) { return ssRule.style.cssText; }
	else { return ssRule.cssText; }
}
function writeRule(ssrRule, ruleCount) {
	var ruleType='';
	var jsNullLink='javascript:void(0);';
	var ruleTypeStyle='font-size:9px; color:#000;';
	var styleTextStyle='font-size:9px; color:#000; margin-left:28px; margin-bottom:-15px;';
	var plusStyle='background-color:#DDD; border:1px solid #BBB; width:20px; height:20px; text-align:center; cursor:hand; margin-right:5px;';
	var minusStyle='background-color:#DDD; border:1px solid orange; width:20px; height:20px; text-align:center; cursor:hand; margin-right:5px;';

	var selector=ssrRule.selectorText;
	if(selector.substring(0,1)==".") { ruleType='<span style="'+ ruleTypeStyle +'">(CLASS)</span>'; }
	else if(selector.substring(0,1)=="#") { ruleType='<span style="'+ ruleTypeStyle +'">(ID)</span>'; }
	else { ruleType='<span style="'+ ruleTypeStyle +'">(TAG)</span>'; }

	document.write('<nobr>');
	document.write('&nbsp;&nbsp;&nbsp;<a href="'+ jsNullLink +'" style="text-decoration:none;"><span id="plus'+ ruleCount +'" style="'+ plusStyle +'" onclick="toggleElement(\'plus'+ ruleCount +'\'); toggleElement(\'minus'+ ruleCount +'\'); toggleElement(\'cssText'+ ruleCount +'\', true);">&nbsp;+&nbsp;</span></a>');
	document.write('<a href="'+ jsNullLink +'" style="text-decoration:none;"><span id="minus'+ ruleCount +'" style="'+ minusStyle +'display:none;" onclick="toggleElement(\'minus'+ ruleCount +'\'); toggleElement(\'cssText'+ ruleCount +'\', true); toggleElement(\'plus'+ ruleCount +'\');">&nbsp;-&nbsp;</span></a>');
	document.write('<span style="'+ getRuleText(ssrRule) +'">'+ ssrRule.selectorText +'</span>&nbsp;&nbsp;&nbsp;'+ ruleType);
	document.write('<span id="cssText'+ ruleCount +'" style="'+ styleTextStyle +'display:none;">&nbsp;&nbsp;&nbsp;{ '+ getRuleText(ssrRule) +' }</span>');
	document.write('</nobr><br>');
	
	totalRuleCount++;
}
function writeStyleSheets() {
	var aStyleSheets=document.styleSheets;
	var iRuleCount=0;
	var styleTitleStyle='font-size:16px; font-weight:bold; color:#000;';
	var styleLoadingStyle='position:absolute; top:0px; right:0px; text-align:center; width:60px; padding:2px; padding-left:8px; padding-right:8px; display:none; font-size:12px; font-weight:bold; color:#FFF; background-color:#F00;';

	// Show "working..." layer
	document.write('<div id="working" style="'+styleLoadingStyle+'">');
	document.write('Working...');
	document.write('</div>');
	
	// Show all attached stylesheets
	document.write('<span style="'+styleTitleStyle+'">');
	document.write('Attached Stylesheets:'); 
	// Expand/Collapse all link
	document.write('&nbsp;<a href="javascript:void(0);" onclick="toggleElement(\'working\', true);setTimeout(\'expColAllRules();\',1);"><span id="toggleLink">Expand All</span></a><br>');
	document.write('</span>');

	function getFileName(sUrl) {
		sUrl = unescape(sUrl);
		if(sUrl.indexOf('\\') != -1) { sUrl = sUrl.substring(sUrl.lastIndexOf('\\')+1, sUrl.length); }
		else if(sUrl.indexOf('/') != -1) { sUrl = sUrl.substring(sUrl.lastIndexOf('/')+1, sUrl.length); }
		return sUrl;
	}
	
	for(i=0; i<aStyleSheets.length; i++) {
		var thisSS=aStyleSheets[i];
		var thisSSname=getFileName(thisSS.href);
		document.write('&nbsp;&nbsp;&nbsp;<a href="#'+ thisSSname +'">'+ thisSSname + '</a><br>');
	}
	
	// Next write in their rules
	for(i2=0; i2<aStyleSheets.length; i2++) {
		var thisSS=aStyleSheets[i2];
		var thisSSname=getFileName(thisSS.href);
		document.write('<br><span style="'+styleTitleStyle+'"><a name="'+thisSSname+'"></a>'+ thisSSname +' Rules: </span><br>');
		
		var thisSSrules=getRules(thisSS);
		for(i3=0; i3<thisSSrules.length; i3++) {
			var thisRule=thisSSrules[i3];
			writeRule(thisRule, iRuleCount);
			iRuleCount++;
		}
	}
	
	document.write('<br>');
}

